/* iRiver iFP 7XX Emulator
   Copyright (C) 2005 Tomasz Malesinski <tmal@mimuw.edu.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _EMURIVER_H_
#define _EMURIVER_H_

#include <stdlib.h>

typedef unsigned long uint32;
typedef signed long sint32;
typedef unsigned long long uint64;
typedef signed long long sint64;
typedef unsigned char uint8;

extern struct cpu *cpu;
extern struct hardware *hardware;

extern char *flash_file;
extern char *prog_flash_file;

void error(const char *format, ...);
void error_sys(const char *format, ...);
void *xmalloc(size_t size);

static inline uint32 ror(uint32 v, int n) {
  return (v >> n) | (v << (32 - n));
}

static inline uint32 asr(uint32 v, int n) {
  return (uint32)(((signed int)v) >> n);
}

static inline uint32 bits(uint32 v, int b, int n) {
  return (v >> b) & ((1 << n) - 1);
}

static inline int sign_extend(uint32 v, int b) {
  if (v & (1 << (b - 1)))
    return ((int)v) - (1 << b);
  else
    return v;
}

void set_profiling(int on);
  
#endif
