#ifndef _FLASHDISK_H_
#define _FLASHDISK_H_

#define SEGMENT_SIZE 1000
#define MAX_N_SEGMENTS 8

struct flash_disk
{
    unsigned short block_map[MAX_N_SEGMENTS][SEGMENT_SIZE];
    short cur_block;
    int cur_phblock_start;
    unsigned char model;
    struct flashimg *flash_img;
};

int flash_disk_read_sectors(struct flash_disk *flash_disk,
                            unsigned long start,
                            int count,
                            void* buf);
int flash_disk_write_sectors(struct flash_disk *flash_disk,
                             unsigned long start,
                             int count,
                             const void* buf);
struct flash_disk *flash_disk_create(struct flashimg *flash_img);
void flash_disk_free(struct flash_disk *flash_disk);

#endif
