#ifndef _FLASHIMGTOOL_H_
#define _FLASHIMGTOOL_H_

#include "config.h"

#define DEBUGF debugf
#define LDEBUGF(...)
#define panicf(...)
#define logf(...)

#define YEAR 2006
#define MONTH 01
#define DAY 01

#define HAVE_FAT16SUPPORT

void debugf(const char *format, ...);

struct mutex { };

static inline mutex_init(struct mutex *m) { }
static inline mutex_lock(struct mutex *m) { }
static inline mutex_unlock(struct mutex *m) { }

static inline unsigned short swap16(unsigned short value)
    /*
      result[15..8] = value[ 7..0];
      result[ 7..0] = value[15..8];
    */
{
    return (value >> 8) | (value << 8);
}

static inline unsigned long swap32(unsigned long value)
    /*
      result[31..24] = value[ 7.. 0];
      result[23..16] = value[15.. 8];
      result[15.. 8] = value[23..16];
      result[ 7.. 0] = value[31..24];
    */
{
    unsigned long hi = swap16(value >> 16);
    unsigned long lo = swap16(value & 0xffff);
    return (lo << 16) | hi;
}

#ifdef CONFIG_BIGENDIAN
#define htole16(x) swap16(x)
#define letoh16(x) swap16(x)
#define htole32(x) swap32(x)
#define letoh32(x) swap32(x)
#else
#define htole16(x) (x)
#define letoh16(x) (x)
#define htole32(x) (x)
#define letoh32(x) (x)
#endif

#define MIN(a, b) (((a)<(b))?(a):(b))

#endif
