/* iRiver iFP 7XX Emulator
   Copyright (C) 2006 Tomasz Malesinski <tmal@mimuw.edu.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _PROFILE_H_
#define _PROFILE_H_

#include "emuriver.h"

#define PROFILE_CTR_CPU_CYCLES 0
#define PROFILE_CTR_IRAM_ACCESSES 1
#define PROFILE_CTR_SRAM_ACCESSES 2
#define PROFILE_CTR_CACHE_MISSES 3
#define PROFILE_CTR_CACHE_HITS 4
#define PROFILE_CTR_CACHE_FLUSHES 5

#define PROFILE_NUM_COUNTERS 6

struct profile_region {
  int *counter[PROFILE_NUM_COUNTERS];
};

struct profile {
  struct profile_region *region[1 << 16];
};

struct profile *create_profile(void);
int profile_add_counter(struct profile *profile, int counter,
			uint32 start, uint32 end);
void profile_count(struct profile *profile, uint32 addr,
		   int counter, int value);
void profile_dump(struct profile *profile, FILE *fp);

#endif
