/* iRiver iFP 7XX Emulator
   Copyright (C) 2005 Tomasz Malesinski <tmal@mimuw.edu.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "ui.h"
#include "config.h"

static struct ui *ui;
static int ui_key_overrides[10];
int ui_init(void) {
#ifdef HAVE_SDL
  ui = &uisdl_functions;
  if (!(*ui->init)())
    return 0;
#endif

  ui = &uicurses_functions;
  if (!(*ui->init)())
    return 0;

  return -1;
}

void ui_cleanup(void) {
  (*ui->cleanup)();
}

void ui_refresh(struct lcd *lcd) {
  (*ui->refresh)(lcd);
}

int ui_get_key(int key) {
  return (*ui->get_key)(key) || ui_key_overrides[key];
}

void ui_set_key_override(int key, int v) {
  if (v >= 0 && v < 10)
    ui_key_overrides[key] = v;
}

void ui_set_status(char *s) {
  (*ui->set_status)(s);
}
